﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Diagnostics;

namespace WatchDog
{
    class Event
    {

        // 1: EventOccurUtilityFailure.txt
        // 2: EventOccurRuntimeInsufficient.txt
        // 3: EventOccurBatteryCriticalLow.txt
        // 4: EventOccurBatteryExhausted.txt
        // 5: EventOccurCapacityInsufficient.txt
        // 6: EventOccurRuntimeWillExhaust.txt
        // 7: EventOccurShutdownTimeInsufficient.txt


        // 10: EventFinishUtilityFailure.txt

        public int eventnr=0;
        public string eventfile="";

        private readonly Logger _logger;

        public Event()
        {
            _logger = Logger.GetLogger();
            eventnr = 0;
            eventfile = "";
            eventnr=CheckEvent();
        }

        public int CheckEvent()
        {
            String directory;
            directory = "C:\\Watchdog\\";

            try
            {
                if (File.Exists(directory + "EventOccurUtilityFailure.txt"))
                {
                    this.eventfile = "EventOccurUtilityFailure.txt";
                    _logger.WriteLine("EventOccurUtilityFailure.txt");
                    File.Delete(directory + "EventOccurUtilityFailure.txt");
                    return 1;
                }
                if (File.Exists(directory + "EventOccurRuntimeInsufficient.txt"))
                {
                    this.eventfile = "EventOccurRuntimeInsufficient.txt";
                    _logger.WriteLine("EventOccurRuntimeInsufficient.txt");
                    File.Delete(directory + "EventOccurRuntimeInsufficient.txt");
                    return 2;
                }
                if (File.Exists(directory + "EventOccurBatteryCriticalLow.txt"))
                {
                    this.eventfile = "EventOccurBatteryCriticalLow.txt";
                    _logger.WriteLine("EventOccurBatteryCriticalLow.txt");
                    File.Delete(directory + "EventOccurBatteryCriticalLow.txt");
                    return 3;
                }
                if (File.Exists(directory + "EventOccurBatteryExhausted.txt"))
                {
                    this.eventfile = "EventOccurBatteryExhausted.txt";
                    _logger.WriteLine("EventOccurBatteryExhausted.txt");
                    File.Delete(directory + "EventOccurBatteryExhausted.txt");
                    return 4;
                }
                if (File.Exists(directory + "EventOccurCapacityInsufficient.txt"))
                {
                    this.eventfile = "EventOccurCapacityInsufficient.txt";
                    _logger.WriteLine("EventOccurCapacityInsufficient.txt");
                    File.Delete(directory + "EventOccurCapacityInsufficient.txt");
                    return 5;
                }
                if (File.Exists(directory + "EventOccurRuntimeWillExhaust.txt"))
                {
                    this.eventfile = "EventOccurRuntimeWillExhaust.txt";
                    _logger.WriteLine("EventOccurRuntimeWillExhaust.txt");
                    File.Delete(directory + "EventOccurRuntimeWillExhaust.txt");
                    return 6;
                }
                if (File.Exists(directory + "EventOccurShutdownTimeInsufficient.txt"))
                {
                    this.eventfile = "EventOccurShutdownTimeInsufficient.txt";
                    _logger.WriteLine("EventOccurShutdownTimeInsufficient.txt");
                    File.Delete(directory + "EventOccurShutdownTimeInsufficient.txt");
                    return 7;
                }
                if (File.Exists(directory + "EventFinishUtilityFailure.txt"))
                {
                    this.eventfile = "EventFinishUtilityFailure.txt";
                    _logger.WriteLine("EventFinishUtilityFailure.txt");
                    File.Delete(directory + "EventFinishUtilityFailure.txt");
                    return 10;
                }
                else
                {
                    this.eventfile = "";
                    return 0;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("TryCatch error.");
                Console.WriteLine(e.ToString());
                _logger.WriteLine("ParkMountTalon6Gracefuly.exe TryCatch: " + e.ToString());
                return 0;
            }

        }

        public void ExecuteParkMountTalon6Gracefuly()
        {
            try
            {
                var proc = new Process();
                proc.StartInfo.FileName = @"C:\Users\C-Boy\Documents\Visual Studio 2017\Projects\ParkMountTalon6Gracefuly\ParkMountTalon6Gracefuly\bin\Debug\ParkMountTalon6Gracefuly.exe";
                proc.StartInfo.UseShellExecute = true;
                proc.StartInfo.RedirectStandardOutput = false;
                proc.Start();
                Console.WriteLine("Starting command ParkMountTalon6Gracefuly.exe...");
                _logger.WriteLine("Starting command ParkMountTalon6Gracefuly.exe...");
                proc.WaitForExit();
                proc.Close();
                Console.WriteLine("Command ParkMountTalon6Gracefuly.exe completed...");
                _logger.WriteLine("Command ParkMountTalon6Gracefuly.exe completed...");
            }
            catch (Exception e)
            {
                Console.WriteLine("TryCatch error.");
                Console.WriteLine(e.ToString());
                _logger.WriteLine("ParkMountTalon6Gracefuly.exe TryCatch: " + e.ToString());
            }
        }

        public void ExecuteKillParkMountTalon6Gracefuly()
        {
            try
            {
                var proc = new Process();
                proc.StartInfo.FileName = @"C:\Users\C-Boy\Documents\Visual Studio 2017\Projects\KillParkMountTalon6Gracefuly\KillParkMountTalon6Gracefuly\bin\Debug\KillParkMountTalon6Gracefuly.exe";
                proc.StartInfo.UseShellExecute = true;
                proc.StartInfo.RedirectStandardOutput = false;
                proc.Start();
                Console.WriteLine("Starting command KillParkMountTalon6Gracefuly.exe...");
                _logger.WriteLine("Starting command KillParkMountTalon6Gracefuly.exe...");
                proc.WaitForExit();
                proc.Close();
                Console.WriteLine("Command KillParkMountTalon6Gracefuly.exe completed...");
                _logger.WriteLine("Command KillParkMountTalon6Gracefuly.exe completed...");
            }
            catch (Exception e)
            {
                Console.WriteLine("TryCatch error.");
                Console.WriteLine(e.ToString());
                _logger.WriteLine("KillParkMountTalon6Gracefuly.exe TryCatch: " + e.ToString());
            }
        }

        public void ExecuteParkMountTalon6Immediately()
        {
            try
            {
                var proc = new Process();
                proc.StartInfo.FileName = @"C:\Users\C-Boy\Documents\Visual Studio 2017\Projects\ParkMountTalon6Immediately\ParkMountTalon6Immediately\bin\Debug\ParkMountTalon6Immediately.exe";
                proc.StartInfo.UseShellExecute = true;
                proc.StartInfo.RedirectStandardOutput = false;
                proc.Start();
                Console.WriteLine("Starting command ParkMountTalon6Immediately.exe...");
                _logger.WriteLine("Starting command ParkMountTalon6Immediately.exe...");
                proc.WaitForExit();
                proc.Close();
                Console.WriteLine("Command ParkMountTalon6Immediately.exe completed...");
                _logger.WriteLine("Command ParkMountTalon6Immediately.exe completed...");
            }
            catch (Exception e)
            {
                Console.WriteLine("TryCatch error.");
                Console.WriteLine(e.ToString());
                _logger.WriteLine("ParkMountTalon6Immediately.exe TryCatch: " + e.ToString());
            }
        }
    }
}
