﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace WatchDog
{
    public sealed class Logger
    {
        private static Logger _logger;
        private static readonly object _synlock = new object();

        private string logpath = "C:\\Watchdog\\Logs";
        private string logfilename = "Watchdog.txt";

        StreamWriter w;

        private Logger()
        {
            logfilename = "Watchdog_" + DateTime.Now.ToString("yy") + DateTime.Now.ToString("MM") + DateTime.Now.ToString("dd") + ".log";

            w = File.AppendText(logpath + "\\" + logfilename);
            w.AutoFlush = true;
            Console.WriteLine("Path of logfile: " + logpath + "\\" + logfilename);
        }

        public static Logger GetLogger()
        {
            if (_logger == null)
            {
                lock (_synlock)
                {
                    if (_logger == null)
                    {
                        _logger = new Logger();
                    }
                }
            }

            return _logger;
        }

        public void WriteLine(string message)
        {
            Console.WriteLine(message);
            w.WriteLine("{0}-{1}  {2}", DateTime.Now.ToShortDateString(), DateTime.Now.ToLongTimeString(), message);
        }
    }
}
