﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace WatchDog
{
    public partial class WatchDogForm : Form
    {
        BackgroundWorker bg;
        Logger _logger = Logger.GetLogger();

        public WatchDogForm()
        {
            InitializeComponent();
            WriteStartLog();
            bg = new BackgroundWorker();
            bg.DoWork += Bg_DoWork;
            bg.ProgressChanged += Bg_ProgressChanged;
            bg.RunWorkerCompleted += Bg_RunWorkerCompleted;
            bg.WorkerReportsProgress = true;
        }

        private void WatchDogForm_Load(object sender, EventArgs e)
        {
            bg.RunWorkerAsync();
        }
       

        private void Bg_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            //MessageBox.Show("Task completed");
        }

        private void Bg_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            this.label_counter.Text = "Loopnr: "+e.ProgressPercentage;
            
            if (!e.UserState.ToString().Equals(string.Empty))
            {
                this.listBox.Items.Add(e.UserState.ToString());
                this.listBox.SelectedIndex = this.listBox.Items.Count - 1;
            }
            
        }

        private void Bg_DoWork(object sender, DoWorkEventArgs e)
        {
            int loopnr;
            loopnr = 0;
            while (true)
            {
                if (loopnr % 60 == 0)
                {
                    bg.ReportProgress(loopnr, DateTime.Now.ToString());
                }
                else
                {
                    bg.ReportProgress(loopnr, "");
                }

                //All the code to check
                Event ev = new Event();
                if (ev.eventnr != 0)
                {
                    bg.ReportProgress(loopnr, ev.eventfile);
                    if (ev.eventnr == 1)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Gracefuly));
                        t.Start();
                        //Task tsk =  Task.Run(() => ev.ExecuteParkMountTalon6Gracefuly());
                        //tsk.Wait();
                    }
                    if (ev.eventnr == 2)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 3)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 4)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 5)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 6)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 7)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteParkMountTalon6Immediately));
                        t.Start();
                    }
                    if (ev.eventnr == 10)
                    {
                        Thread t = new Thread(new ThreadStart(ev.ExecuteKillParkMountTalon6Gracefuly));
                        t.Start();
                    }
                }
                ev = null;
                
                loopnr++;
                Thread.Sleep(1000); //do some task
            }

            //bg.ReportProgress(loopnr);
        }

        private void notifyIcon1_MouseClick(object sender, MouseEventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }

        private void WatchDogForm_Resize(object sender, EventArgs e)
        {
            if (WindowState == FormWindowState.Minimized)
            {
                this.Hide();
            }
        }

        private void WatchDogForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = (MessageBox.Show("Are you sure you want to close?", "Confirm Close", MessageBoxButtons.YesNo) == DialogResult.No);
        }

        private void WriteStartLog()
        {
            _logger.WriteLine(" ");
            _logger.WriteLine("================");
            _logger.WriteLine("Execute Watchdog");
            _logger.WriteLine("================");
        }
    }
}
